﻿###########################################################################
#Script to run RPA macros and check on their result via the command line
###########################################################################


function PlayAndWait2 ([string]$macro, [string]$var1, [string]$var2, [string]$var3)
{


$timeout_seconds = 55 #max time in seconds allowed for macro to complete (change this value if  your macros takes longer to run)
$path_downloaddir = "F:\Google drive 2plus\Crypto\projet crypto\Arbitrage\Automation on DEX\logs\" #where the kantu log file is stored ("downloaded") *THIS MUST BE THE BROWSER DOWNLOAD FOLDER*, as specified in the browser settings
$path_autorun_html = "F:\Google drive 2plus\Crypto\projet crypto\Arbitrage\Automation on DEX\html\ui.vision.html"


#Optional: Kill Chrome instances (if any open)
#taskkill /F /IM chrome.exe /T 

#Create log file. Here the RPA software will store the result of the macro run
$log = "log_" + $(get-date -f MM-dd-yyyy_HH_mm_ss) + ".txt" 
$path_log = $path_downloaddir + $log 


#Build command line (1=CHROME, 2=FIREFOX, 3=EDGE)
$browser = 1
Switch ($browser) {
1 {$cmd = "${env:ProgramFiles(x86)}\Google\Chrome\Application\chrome.exe"; break}
2 {$cmd = "${env:ProgramFiles}\Mozilla Firefox\firefox.exe"; break} #For FIREFOX
3 {$cmd = "${env:ProgramFiles(x86)}\Microsoft\Edge\Application\msedge.exe"; break} #For EDGE 
}

$arg = """file:///"+ $path_autorun_html + "?macro="+ $macro +'&cmd_var1=' + $var1 + '&cmd_var2=' + $var2+ '&cmd_var3=' + $var3+"&direct=1&closeRPA=0"+"&savelog="+$log+""""
 

Start-Process -FilePath $cmd -ArgumentList $arg #Launch the browser and run the macro

#############Wait for macro to complete => Wait for log file to appear in download folder
$status_runtime = 0
Write-Host  "Log file will show up at " + $path_log
while (!(Test-Path $path_log) -and ($status_runtime -lt $timeout_seconds)) 
{ 
    Write-Host  "Waiting for macro to finish, seconds=" $status_runtime
    Start-Sleep 1
    $status_runtime = $status_runtime + 1 
}


#Macro done - or timeout exceeded:
if ($status_runtime -lt $timeout_seconds)
{
    #Read FIRST line of log file, which contains the status of the last run
    $status_text = Get-Content $path_log -First 1


    #Check if macro completed OK or not
    $status_int = -1     
    If ($status_text -contains "Status=OK") {$status_int = 1}

}
else
{
    $status_text =  "Macro did not complete within the time given:" + $timeout_seconds
    $status_int = -2
    #Cleanup => Kill Chrome instance 
    #taskkill /F /IM chrome.exe /T   
}

#remove-item $path_log #clean up
return $status_int, $status_text, $status_runtime
}


###########################################################################
#        Main program starts here
###########################################################################


PlayAndWait2 Init 


$testreport = "F:\\testreport.txt"
$i=0
while ($true)  {

    $result = PlayAndWait2 swap_on_mist-t flex law 1 
   
    Start-Sleep -Seconds 3

    $changement = Test-Path -Path 'F:\csv_output.csv'
       

    $errortext = $result[1] #Get error text or OK
    $runtime = $result[2] #Get runtime
    $report = "Macro1 runtime: ("+$runtime+" seconds), result: "+ $errortext
    Write-Host $report
    Write-Host $changement
    Add-content $testreport -value ($report)

    Start-Sleep -Seconds 5


    if($errortext -match 'Status=Error'){ 

        & "F:\Debloc.ps1"
        Start-Sleep -Seconds 10

   }elseif($changement) {
   
        PlayAndWait2 Init
        PlayAndWait2 CSV_write flex
        PlayAndWait2 CSV_write law
        PlayAndWait2 CSV_save flex sB law
        Remove-Item 'F:\csv_output.csv'
        Write-Host "i=0"
        $i=0
   }else {
   
   }      
}